// Standard TI-86 TCC function library
// Copyright Adam Chlipala 1997-98

// Standard font characters

#define font_binary 0x001
#define font_octal 0x002
#define font_decimal 0x003
#define font_hexadecimal 0x004
#define font_convert 0x005
#define font_sqUp 0x006
#define font_sqDown 0x007
#define font_shortegral 0x008
#define font_cross 0x009
#define font_hexA 0x00A
#define font_hexB 0x00B
#define font_hexC 0x00C
#define font_hexD 0x00D
#define font_hexE 0x00E
#define font_hexF 0x00F
#define font_root 0x010
#define font_inverse 0x011
#define font_square 0x012
#define font_angle 0x013
#define font_degree 0x014
#define font_radian 0x015
#define font_transpose 0x016
#define font_LE 0x017
#define font_NE 0x018
#define font_GE 0x019
#define font_neg 0x01A
#define font_exponent 0x01B
#define font_store 0x01C
#define font_ten 0x01D
#define font_upArrow 0x01E
#define font_downArrow 0x01F
#define font_space 0x020
#define font_exclam 0x021
#define font_quote 0x022
#define font_pound 0x023
#define font_dollar 0x024
#define font_percent 0x025
#define font_ampersand 0x026
#define font_apostrophe 0x027
#define font_lParen 0x028
#define font_rParen 0x029
#define font_asterisk 0x02A
#define font_plusSign 0x02B
#define font_comma 0x02C
#define font_dash 0x02D
#define font_period 0x02E
#define font_slash 0x02F
#define font_0 0x030
#define font_1 0x031
#define font_2 0x032
#define font_3 0x033
#define font_4 0x034
#define font_5 0x035
#define font_6 0x036
#define font_7 0x037
#define font_8 0x038
#define font_9 0x039
#define font_colon 0x03A
#define font_semicolon 0x03B
#define font_LT 0x03C
#define font_EQ 0x03D
#define font_GT 0x03E
#define font_question 0x03F
#define font_atSign 0x040
#define font_lBrack 0x05B
#define font_backslash 0x05C
#define font_rBrack 0x05D
#define font_caret 0x05E
#define font_underscore 0x05F
#define font_backquote 0x060
#define font_lBrace 0x07B
#define font_bar 0x07C
#define font_rBrace 0x07D
#define font_tilde 0x07E
#define font_invEQ 0x07F
#define font_sub0 0x080
#define font_sub1 0x081
#define font_sub2 0x082
#define font_sub3 0x083
#define font_sub4 0x084
#define font_sub5 0x085
#define font_sub6 0x086
#define font_sub7 0x087
#define font_sub8 0x088
#define font_sub9 0x089
#define font_capAAcute 0x08A
#define font_capAGrave 0x08B
#define font_capACaret 0x08C
#define font_capADier 0x08D
#define font_aAcute 0x08E
#define font_aGrave 0x08F
#define font_aCaret 0x090
#define font_aDier 0x091
#define font_capEAcute 0x092
#define font_capEGrave 0x093
#define font_capECaret 0x094
#define font_capEDier 0x095
#define font_eAcute 0x096
#define font_eGrave 0x097
#define font_eCaret 0x098
#define font_eDier 0x099
#define font_capIAcute 0x09A
#define font_capIGrave 0x09B
#define font_capICaret 0x09C
#define font_capIDier 0x09D
#define font_iAcute 0x09E
#define font_iGrave 0x09F
#define font_iCaret 0x0A0
#define font_iDier 0x0A1
#define font_capOAcute 0x0A2
#define font_capOGrave 0x0A3
#define font_capOCaret 0x0A4
#define font_capODier 0x0A5
#define font_oAcute 0x0A6
#define font_oGrave 0x0A7
#define font_oCaret 0x0A8
#define font_oDier 0x0A9
#define font_capUAcute 0x0AA
#define font_capUGrave 0x0AB
#define font_capUCaret 0x0AC
#define font_capUDier 0x0AD
#define font_uAcute 0x0AE
#define font_uGrave 0x0AF
#define font_uCaret 0x0B0
#define font_uDier 0x0B1
#define font_capCCed 0x0B2
#define font_cCed 0x0B3
#define font_capNTilde 0x0B4
#define font_nTilde 0x0B5
#define font_accent 0x0B6
#define font_grave 0x0B7
#define font_dieresis 0x0B8
#define font_quesDown 0x0B9
#define font_exclamDown 0x0BA
#define font_alpha 0x0BB
#define font_beta 0x0BC
#define font_gamma 0x0BD
#define font_capDelta 0x0BE
#define font_delta 0x0BF
#define font_epsilon 0x0C0
#define font_theta 0x0C1
#define font_lambda 0x0C2
#define font_mu 0x0C3
#define font_pi 0x0C4
#define font_rho 0x0C5
#define font_capSigma 0x0C6
#define font_sigma 0x0C7
#define font_tau 0x0C8
#define font_phi 0x0C9
#define font_capOmega 0x0CA
#define font_xMean 0x0CB
#define font_yMean 0x0CC
#define font_supX 0x0CD
#define font_ellipsis 0x0CE
#define font_left 0x0CF
#define font_block 0x0D0
#define font_per 0x0D1
#define font_hyphen 0x0D2
#define font_area 0x0D3
#define font_temp 0x0D4
#define font_cube 0x0D5
#define font_enter 0x0D6
#define font_blockArrow 0x0D7
#define font_a 0x061
#define font_b 0x062
#define font_c 0x063
#define font_d 0x064
#define font_e 0x065
#define font_f 0x066
#define font_g 0x067
#define font_h 0x068
#define font_i 0x069
#define font_j 0x06A
#define font_k 0x06B
#define font_l 0x06C
#define font_m 0x06D
#define font_n 0x06E
#define font_o 0x06F
#define font_p 0x070
#define font_q 0x071
#define font_r 0x072
#define font_s 0x073
#define font_t 0x074
#define font_u 0x075
#define font_v 0x076
#define font_w 0x077
#define font_x 0x078
#define font_y 0x079
#define font_z 0x07A
#define font_capA 0x041
#define font_capB 0x042
#define font_capC 0x043
#define font_capD 0x044
#define font_capE 0x045
#define font_capF 0x046
#define font_capG 0x047
#define font_capH 0x048
#define font_capI 0x049
#define font_capJ 0x04A
#define font_capK 0x04B
#define font_capL 0x04C
#define font_capM 0x04D
#define font_capN 0x04E
#define font_capO 0x04F
#define font_capP 0x050
#define font_capQ 0x051
#define font_capR 0x052
#define font_capS 0x053
#define font_capT 0x054
#define font_capU 0x055
#define font_capV 0x056
#define font_capW 0x057
#define font_capX 0x058
#define font_capY 0x059
#define font_capZ 0x05A

// getkey() character codes

#define key_Right 0x001
#define key_Left 0x002
#define key_Up 0x003
#define key_Down 0x004
#define key_Colon 0x005
#define key_Enter 0x006
#define key_Exit 0x007
#define key_Clear 0x008
#define key_Del 0x009
#define key_Ins 0x00A
#define key_Next 0x00B
#define key_Add 0x00C
#define key_Sub 0x00D
#define key_Mul 0x00E
#define key_Div 0x00F
#define key_Expon 0x010
#define key_LParen 0x011
#define key_RParen 0x012
#define key_LBrack 0x013
#define key_RBrack 0x014
#define key_Equal 0x015
#define key_Store 0x016
#define key_Recall 0x017
#define key_Comma 0x018
#define key_Ang 0x019
#define key_Chs 0x01A
#define key_DecPnt 0x01B
#define key_0 0x01C
#define key_1 0x01D
#define key_2 0x01E
#define key_3 0x01F
#define key_4 0x020
#define key_5 0x021
#define key_6 0x022
#define key_7 0x023
#define key_8 0x024
#define key_9 0x025
#define key_EE 0x026
#define key_Space 0x027
#define key_CapA 0x028
#define key_CapB 0x029
#define key_CapC 0x02A
#define key_CapD 0x02B
#define key_CapE 0x02C
#define key_CapF 0x02D
#define key_CapG 0x02E
#define key_CapH 0x02F
#define key_CapI 0x030
#define key_CapJ 0x031
#define key_CapK 0x032
#define key_CapL 0x033
#define key_CapM 0x034
#define key_CapN 0x035
#define key_CapO 0x036
#define key_CapP 0x037
#define key_CapQ 0x038
#define key_CapR 0x039
#define key_CapS 0x03A
#define key_CapT 0x03B
#define key_CapU 0x03C
#define key_CapV 0x03D
#define key_CapW 0x03E
#define key_CapX 0x03F
#define key_CapY 0x040
#define key_CapZ 0x041
#define key_a 0x042
#define key_b 0x043
#define key_c 0x044
#define key_d 0x045
#define key_e 0x046
#define key_f 0x047
#define key_g 0x048
#define key_h 0x049
#define key_i 0x04A
#define key_j 0x04B
#define key_k 0x04C
#define key_l 0x04D
#define key_m 0x04E
#define key_n 0x04F
#define key_o 0x050
#define key_p 0x051
#define key_q 0x052
#define key_r 0x053
#define key_s 0x054
#define key_t 0x055
#define key_u 0x056
#define key_v 0x057
#define key_w 0x058
#define key_x 0x059
#define key_y 0x05A
#define key_z 0x05B
#define key_Varx 0x05C
#define key_Ans 0x05D
#define key_Pi 0x05E
#define key_Inv 0x05F
#define key_Sin 0x060
#define key_ASin 0x061
#define key_Cos 0x062
#define key_ACos 0x063
#define key_Tan 0x064
#define key_ATan 0x065
#define key_Square 0x066
#define key_Sqrt 0x067
#define key_Ln 0x068
#define key_Exp 0x069
#define key_Log 0x06A
#define key_ALog 0x06B
#define key_Math 0x06C
#define key_Cplx 0x06D
#define key_String 0x06E
#define key_Test 0x06F
#define key_Conv 0x070
#define key_Char 0x071
#define key_Base 0x072
#define key_Custom 0x073
#define key_Vars 0x074
#define key_Catalog 0x075
#define key_Quit 0x076
#define key_LastEnt 0x077
#define key_LinkIO 0x078
#define key_Mem 0x079
#define key_List 0x07A
#define key_Vector 0x07B
#define key_Const 0x07C
#define key_Matrix 0x07D
#define key_Poly 0x07E
#define key_Simult 0x07F
#define key_Stat 0x080
#define key_GrMenu 0x081
#define key_Mode 0x082
#define key_Prgm 0x083
#define key_Calcu 0x084
#define key_Solver 0x085h
#define key_Table 0x086h
#define key_EOL 0x088
#define key_CUSTM 0x093
#define key_F1 0x0C2
#define key_F2 0x0C3
#define key_F3 0x0C4
#define key_F4 0x0C5
#define key_F5 0x0C6
#define key_F6 0x0C7
#define key_F7 0x0C8
#define key_F8 0x0C9
#define key_F9 0x0CA
#define key_F10 0x0CB
#define key_GRAPH 0x081

// I/O ports

#define port_screen 0
#define port_keypad 1
#define port_contrast 2
#define port_on 3
#define port_lcd 3
#define port_power 4
#define port_page1 5
#define port_page2 6
#define port_link 7

// Graphics constants

#define SCREEN_W 128
#define SCREEN_H 64

// Miscellaneous pointers

short *_contrast = (short *)0xC008;

// Calculator specific routines

int abs(int n) {

_asm_setreg(n, de);
#asm
	bit 7,d
	jr z,abs1
	ld hl,0
	or a
	sbc hl,de
	ld d,h
	ld e,l
abs1:
#endasm
_asm_setvar(n, de);
return n;

}

void puts(char *string) {

_asm_setreg(string, de);
#asm
	ld h,d
	ld l,e
	call _puts
	call _newline
#endasm

}

void putchar(char num) {

_asm_setreg(num, a);
#asm call _putc

}

void put8(short n) {
putchar('0' + n);
}

void put16(int n) {
_asm_setreg(n, de);
#asm
	ld c,'0'
	ld a,d
	add a,c
	call _putc
	ld a,e
	add a,c
	call _putc
#endasm
}

void put16b(int n) {
_asm_setreg(n, de);
#asm
	ld a,d
	call _putc
	ld a,e
	call _putc
#endasm
}

short getkey() {

short ret;

#asm call _getkey
_asm_setvar(ret, a);
return ret;

}

void locate(short x, short y) {

_asm_setreg(y, e);
_asm_setreg(x, d);
#asm ld ($C00F),de

}

void clear_lcd() {
#asm call _clrLCD
}

void clear_screen() {
#asm call _clrScrn
}

short set_contrast(short c) {

if (c >= (short)0 && c <= (short)0x1F) {
	*_contrast = c;
	_asm_setreg(c, a);
	#asm out (2),a
	return c;
	}
else {
	return 0x20;
	}

}

void delay(int c) {

while (--c)
#asm nop

}

void cls() {

clear_screen();
locate((short)0, (short)0);

}

int find_pixel(short x, short y, short *a) {

int ret;
short tmp;

_asm_setreg(x, d);
_asm_setreg(y, e);
#asm
	ld b,d
	ld c,e
	ld a,b
	and 7
	ld hl,_offsets
	ld e,a
	ld d,0
	add hl,de

	ld a,c
	add a,a
	add a,a
	rl d
	add a,a
	rl d
	add a,a
	rl d
	srl b
	srl b
	srl b
	or b
	ld e,a
	ld a,(hl)
	dec d
	dec d
	dec d
	dec d
	push af
#endasm
_asm_setvar(ret, de);
#asm
	pop af
	ld e,a
#endasm
_asm_setvar(tmp, e);
*a = tmp;
return ret;

}

#define RAND_MAX 65525
int _rnd_seed;

void srand(int n) {
_rnd_seed = n;
}

void srand_r() {

short n1, n2;

#asm
	ld a,r
	ld e,a
#endasm
_asm_setvar(n1, e);
#asm
	ld a,r
	ld e,a
#endasm
_asm_setvar(n2, e);
_rnd_seed = (n1 << 8) + n2;

}

int rand() {

return _rnd_seed = _rnd_seed * 11035 + 12345;

}
